General cleanup of command line parsing to allow "busybox" to work as a prefix.
(I.E. any argv[0] that starts with "busybox" winds up in busybox_main().)
Added testing/busybox.tests which tests the following permutations:
./busybox
./busybox-suffix
./busybox cat
./busybox-suffix cat
./busybox --help
./busybox-suffix --help
./busybox --help cat
./busybox-suffix --help cat
./busybox --help unknown
./busybox-suffix --help unknown
./unknown
Also repair the test suite so ./runtest calls the ".tests" scripts properly.
Note: you can now go "busybox busybox busbox ls -l" and it'll take it. The
new code is pretty generic. I can block that if anybody can come up with a
good reason to...
diff --git a/testsuite/busybox.tests b/testsuite/busybox.tests
new file mode 100755
index 0000000..f26f01b
--- /dev/null
+++ b/testsuite/busybox.tests
@@ -0,0 +1,123 @@
+#!/bin/sh
+
+# Tests for busybox applet itself.
+# Copyright 2005 by Rob Landley <rob@landley.net>
+# Licensed under GPL v2, see file LICENSE for details.
+
+if [ ${#COMMAND} -eq 0 ]; then COMMAND=busybox; fi
+. testing.sh
+
+# We'll assume "cat" is built in, because we need some other command to test.
+
+HELPDUMP=`$COMMAND`
+
+# The gratuitous "\n"s are due to a shell idiosyncrasy: environment variables
+# seem to strip trailing whitespace, which makes cmp and diff unhappy.
+
+ln -s `which "$COMMAND"` busybox-suffix
+ln -s `which "$COMMAND"` unknown
+
+for i in busybox busybox-suffix
+do
+ # The gratuitous "\n"s are due to a shell idiosyncrasy:
+ # environment variables seem to strip trailing whitespace.
+
+ testing "$i" "" "$HELPDUMP\n\n" "" ""
+
+ testing "$i cat" "cat" "moo" "" "moo"
+
+ testing "$i unknown" "unknown 2>&1" \
+ "unknown: applet not found\n" "" ""
+
+ testing "$i --help" "--help 2>&1" "$HELPDUMP\n\n" "" ""
+
+ testing "$i --help cat" "--help cat 2>&1 | grep prints" \
+ "Concatenates FILE(s) and prints them to stdout.\n" "" ""
+
+ testing "$i --help unknown" "--help unknown 2>&1" \
+ "unknown: applet not found\n" "" ""
+
+ COMMAND=./busybox-suffix
+done
+
+COMMAND="./unknown"
+testing "busybox as unknown name" "2>&1" "unknown: applet not found\n" "" ""
+
+rm -f busybox-suffix unknown
+
+exit
+
+General cleanup of command line parsing to allow "busybox" to work as a prefix.
+(I.E. any argv[0] that starts with "busybox" winds up in busybox_main().)
+
+Tests:
+./busybox
+./busybox-walrus
+./busybox ls
+./busybox-walrus ls
+./busybox --help
+./busybox-walrus --help
+./busybox --help ls
+./busybox-walrus --help ls
+./busybox --help walrus
+./busybox-walrus --help walrus
+
+
+
+
+
+
+
+
+
+# These tests require the full option set.
+
+# Longish chunk of data re-used by the next few tests
+
+data="42 1 3 woot
+42 1 010 zoology
+egg 1 2 papyrus
+7 3 42 soup
+999 3 0 algebra
+"
+
+# Sorting with keys
+
+testing "sort one key" "-k4,4 input" \
+"999 3 0 algebra
+egg 1 2 papyrus
+7 3 42 soup
+42 1 3 woot
+42 1 010 zoology
+" "$data" ""
+
+testing "sort key range with numeric option" "-k2,3n input" \
+"42 1 010 zoology
+42 1 3 woot
+egg 1 2 papyrus
+7 3 42 soup
+999 3 0 algebra
+" "$data" ""
+
+# Busybox is definitely doing this one wrong just now...
+
+testing "sort key range with numeric option and global reverse" \
+"-k2,3n -r input" \
+"egg 1 2 papyrus
+42 1 3 woot
+42 1 010 zoology
+999 3 0 algebra
+7 3 42 soup
+" "$data" ""
+
+#
+
+testing "sort key range with multiple options" "-k2,3rn input" \
+"7 3 42 soup
+999 3 0 algebra
+42 1 010 zoology
+42 1 3 woot
+egg 1 2 papyrus
+" "$data" ""
+
+exit $FAILCOUNT
diff --git a/testsuite/runtest b/testsuite/runtest
index 91b7943..6a0dc9d 100755
--- a/testsuite/runtest
+++ b/testsuite/runtest
@@ -97,8 +97,8 @@
status=1
fi
fi
-
- if [ -f "$applet".tests ]
+ applet=`echo "$applet" | sed -n 's/\.tests$//p'`
+ if [ ${#applet} != 0 ]
then
rm -f links/"$applet"
ln -s ../../busybox links/"$applet"
diff --git a/testsuite/testing.sh b/testsuite/testing.sh
index d516f72..0925d09 100755
--- a/testsuite/testing.sh
+++ b/testsuite/testing.sh
@@ -48,13 +48,13 @@
if [ $? -ne 0 ]
then
FAILCOUNT=$[$FAILCOUNT+1]
- echo FAIL:"$1"
+ echo "FAIL: $1"
if [ $verbose ]
then
diff -u expected actual
fi
else
- echo PASS:"$1"
+ echo "PASS: $1"
fi
rm -f input expected actual